org.openide.util

## Class Lookup.Template<T>

- java.lang.Object
- - org.openide.util.Lookup.Template<T>

- Enclosing class:
    Lookup

      public static final class Lookup.Template<T>
      extends Object

  Template defining a pattern to filter instances by.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Template()` Deprecated. Use `new Template (Object.class)` which is going to be better typed with JDK1.5 templates and should produce the same result.
    `Template(Class<T> type)` Create a simple template matching by class.
    `Template(Class<T> type, String id, T instance)` Constructor to create new template.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(Object obj)` Indicates whether some other object is "equal to" this one.
    `String` | `getId()` Get the persistent identifier being searched for, if any.
    `T` | `getInstance()` Get the specific instance being searched for, if any.
    `Class<T>` | `getType()` Get the class (or superclass or interface) to search for.
    `int` | `hashCode()` Returns a hash code value for the object.
    `String` | `toString()` Returns a string representation of the object.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Template

          @Deprecated
          public Template()

      Deprecated. Use `new Template (Object.class)` which is going to be better typed with JDK1.5 templates and should produce the same result.
      General template to find all possible instances.

    - #### Template

          public Template(Class<T> type)

      Create a simple template matching by class.
      Parameters:
        `type` - the class of service we are looking for (subclasses will match)

    - #### Template

          public Template(Class<T> type,
                          String id,
                          T instance)

      Constructor to create new template.
      Parameters:
        `type` - the class of service we are looking for or `null` to leave unspecified
        `id` - the ID of the item/service we are looking for or `null` to leave unspecified
        `instance` - a specific known instance to look for or `null` to leave unspecified

  - ### Method Detail

    - #### getType

          public Class<T> getType()

      Get the class (or superclass or interface) to search for. If it was not specified in the constructor, `Object` is used as this will match any instance.
      Returns:
        the class to search for

    - #### getId

          public String getId()

      Get the persistent identifier being searched for, if any.
      Returns:
        the ID or `null`
      Since:
        1.8
      See Also:
        `Lookup.Item.getId()`

    - #### getInstance

          public T getInstance()

      Get the specific instance being searched for, if any. Most useful for finding an `Item` when the instance is already known.
      Returns:
        the object to find or `null`
      Since:
        1.8

    - #### hashCode

          public int hashCode()

      Description copied from class: `Object`
      Returns a hash code value for the object. This method is supported for the benefit of hash tables such as those provided by `HashMap`.

      The general contract of `hashCode` is:

      - Whenever it is invoked on the same object more than once during an execution of a Java application, the `hashCode` method must consistently return the same integer, provided no information used in `equals` comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application.
      - If two objects are equal according to the `equals(Object)` method, then calling the `hashCode` method on each of the two objects must produce the same integer result.
      - It is not required that if two objects are unequal according to the `Object.equals(java.lang.Object)` method, then calling the `hashCode` method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hash tables.

      As much as is reasonably practical, the hashCode method defined by class `Object` does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)

      Overrides:
        `hashCode` in class `Object`
      Returns:
        a hash code value for this object.
      See Also:
        `Object.equals(java.lang.Object)`, `System.identityHashCode(java.lang.Object)`

    - #### equals

          public boolean equals(Object obj)

      Description copied from class: `Object`
      Indicates whether some other object is "equal to" this one.

      The `equals` method implements an equivalence relation on non-null object references:

      - It is reflexive: for any non-null reference value `x`, `x.equals(x)` should return `true`.
      - It is symmetric: for any non-null reference values `x` and `y`, `x.equals(y)` should return `true` if and only if `y.equals(x)` returns `true`.
      - It is transitive: for any non-null reference values `x`, `y`, and `z`, if `x.equals(y)` returns `true` and `y.equals(z)` returns `true`, then `x.equals(z)` should return `true`.
      - It is consistent: for any non-null reference values `x` and `y`, multiple invocations of `x.equals(y)` consistently return `true` or consistently return `false`, provided no information used in `equals` comparisons on the objects is modified.
      - For any non-null reference value `x`, `x.equals(null)` should return `false`.

      The `equals` method for class `Object` implements the most discriminating possible equivalence relation on objects; that is, for any non-null reference values `x` and `y`, this method returns `true` if and only if `x` and `y` refer to the same object (`x == y` has the value `true`).

      Note that it is generally necessary to override the `hashCode` method whenever this method is overridden, so as to maintain the general contract for the `hashCode` method, which states that equal objects must have equal hash codes.

      Overrides:
        `equals` in class `Object`
      Parameters:
        `obj` - the reference object with which to compare.
      Returns:
        `true` if this object is the same as the obj argument; `false` otherwise.
      See Also:
        `Object.hashCode()`, `HashMap`

    - #### toString

          public String toString()

      Description copied from class: `Object`
      Returns a string representation of the object. In general, the `toString` method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method.

      The `toString` method for class `Object` returns a string consisting of the name of the class of which the object is an instance, the at-sign character ``@`', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of:

      >      getClass().getName() + '@' + Integer.toHexString(hashCode())

      Overrides:
        `toString` in class `Object`
      Returns:
        a string representation of the object.

Copyright © 2025 API Design. All Rights Reserved.